org.apache.olingo.odata2.jpa.processor.api.model

## Interface JPAEdmPropertyView

- All Superinterfaces:
    JPAEdmBaseView

      public interface JPAEdmPropertyView
      extends JPAEdmBaseView

  A view on Java Persistence Entity Attributes and EDM properties. Java Persistence Attributes of type
  1. embedded ID - are converted into EDM keys
  2. ID - are converted into EDM keys
  3. attributes - are converted into EDM properties
  4. embeddable type - are converted into EDM complex properties
  5. relationships - are converted into Associations/Navigation properties

  The implementation of the view provides access to EDM properties for a given JPA EDM entity type. The view acts as a container for consistent list of EDM properties of an EDM entity type. EDM property is consistent only if there exists at least one property in the entity type and there is at least one key property.

  See Also:
    `JPAEdmKeyView`, `JPAEdmNavigationPropertyView`
  Do not implement this interface or derive from class.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `List<Property>` | `getEdmPropertyList()` The method returns a list of Properties for the given Entity Type.
    `SimpleProperty` | `getEdmSimpleProperty()` The method returns a simple EDM property.
    `javax.persistence.metamodel.Attribute<?,?>` | `getJPAAttribute()` The method returns a JPA Attribute for the given JPA entity type.
    `JPAEdmComplexTypeView` | `getJPAEdmComplexTypeView()` The method returns a JPA EDM Complex Type view that holds the property view.
    `JPAEdmEntityTypeView` | `getJPAEdmEntityTypeView()` The method returns a JPA EDM Entity Type view that holds the property view.
    `JPAEdmKeyView` | `getJPAEdmKeyView()` The method returns a JPA EDM key view.
    `JPAEdmNavigationPropertyView` | `getJPAEdmNavigationPropertyView()` The method returns a JPA EDM navigation property view.
    `List<String[]>` | `getJPAJoinColumns()` The method returns a list of JPA Join Column Annotations for the given JPA Attribute
    `javax.persistence.metamodel.Attribute<?,?>` | `getJPAReferencedAttribute()` The method returns a JPA Attribute referenced by a JPA Attribute in the `JoinColumn` annotation for the given JPA entity type .

    - ### Methods inherited from interface org.apache.olingo.odata2.jpa.processor.api.model.JPAEdmBaseView

      `clean, getBuilder, getJPAEdmExtension, getJPAEdmMappingModelAccess, getJPAMetaModel, getpUnitName, isConsistent, isDefaultNamingSkipped`

- - ### Method Detail

    - #### getEdmSimpleProperty

          SimpleProperty getEdmSimpleProperty()

      The method returns a simple EDM property.
      Returns:
        an instance of type `SimpleProperty`

    - #### getJPAEdmKeyView

          JPAEdmKeyView getJPAEdmKeyView()

      The method returns a JPA EDM key view.
      Returns:
        an instance of type `JPAEdmKeyView`

    - #### getEdmPropertyList

          List<Property> getEdmPropertyList()

      The method returns a list of Properties for the given Entity Type.
      Returns:
        a list of `Property`

    - #### getJPAAttribute

          javax.persistence.metamodel.Attribute<?,?> getJPAAttribute()

      The method returns a JPA Attribute for the given JPA entity type.
      Returns:
        an instance of type ``

    - #### getJPAReferencedAttribute

          javax.persistence.metamodel.Attribute<?,?> getJPAReferencedAttribute()

      The method returns a JPA Attribute referenced by a JPA Attribute in the `JoinColumn` annotation for the given JPA entity type .
      Returns:
        an instance of type ``

    - #### getJPAEdmNavigationPropertyView

          JPAEdmNavigationPropertyView getJPAEdmNavigationPropertyView()

      The method returns a JPA EDM navigation property view.
      Returns:
        an instance of type `JPAEdmNavigationPropertyView`

    - #### getJPAEdmEntityTypeView

          JPAEdmEntityTypeView getJPAEdmEntityTypeView()

      The method returns a JPA EDM Entity Type view that holds the property view.
      Returns:
        an instance of type `JPAEdmEntityTypeView`

    - #### getJPAEdmComplexTypeView

          JPAEdmComplexTypeView getJPAEdmComplexTypeView()

      The method returns a JPA EDM Complex Type view that holds the property view.
      Returns:
        an instance of type `JPAEdmComplexTypeView`

    - #### getJPAJoinColumns

          List<String[]> getJPAJoinColumns()

      The method returns a list of JPA Join Column Annotations for the given JPA Attribute
      Returns:
        a list of Array of Strings. First element in the Array represents the join column name and the second element in the array represents the referencedColumn name

Copyright © 2013-2022 The Apache Software Foundation. All Rights Reserved.